//
/**********************************************************************
This code was created to demonstrate  RSACookie API with a simple HTML page containing
an HTML Form with two text fields, which supply user data and a tag.
Four buttons allow a tester to
 create/change a 3-d party data field,
 look at it,
 delete it, and
 try to tamper it, i.e. to change data and to check its validity after that.


************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>


//IF any linking problem regarding SD_BOOL 
//just change 
// typedef signed  long int SD_BOOL to typedef signed   int SD_BOOL
#ifdef LINUX_5_1_32
typedef signed   int SD_BOOL;
#endif

#ifdef LINUX_4_32
typedef signed  int SD_BOOL;
#endif

#ifdef LINUX_5_1_64
typedef signed  int SD_BOOL;
#endif

#ifdef SOL
typedef signed  int SD_BOOL;
#endif

#include "rsacookieapi.h"

#define TRUE ((SD_BOOL) 1)
#define FALSE ((SD_BOOL) 0)
#define TAG_LENGTH 1024
#define MAX_DATA_LENGTH 2048
#define TAG "atag"
#define TAG_DATA "somedata"
#define CREATE_BUTTON "ButtonCreate"
#define SHOW_BUTTON "ButtonShow"
#define DELETE_BUTTON "ButtonDelete"
#define TAMPER_BUTTON "ButtonTamper"
#define CHECKBOX "encrypted"
#define BUTTON "Button"
#define N_BUTTONS 4
#define N_FIELDS 3
#define EXAMPLE_ERROR 0
#define URL_EQ "Z3D"
#define URL_NN "Z00"


static void Print_Ol_Cookies(char *Cookie);
static void Print_Greeting(const char *User_Name);
static void Print_3d_Party(char *Tag, const char *Old_Cookie, SD_BOOL Encrypted);
static void Print_Origin(const char* Action);
static void Print_Logoff(LPCSTR CSRFToken);
static void Report_Error(const char* Error, int detail, LPCSTR CSRFToken);
static void Supply_Headers(LPCSTR v);

  int main()
  {
	char	*form_data,									//data from the form
			*copy_form_data,							//a copy of the same
			*ID,										//see assignmenmt below	via getenv()
			*Cookie,									// ---------"---------
			*User,										// ---------"---------
			*BrowserIP,									// ---------"---------
			*Agent,										// ---------"---------
			*token,										// a token in the form_data
			*cp1,										// a character pointer
			*cp,										// a character pointer
			Tag[TAG_LENGTH]={0},						//Tag
			Data[MAX_DATA_LENGTH]={0},					//3-d party cookie (TAGged) data
			TagEQData[TAG_LENGTH + MAX_DATA_LENGTH],	//"tag=Data"
			cBuffer[MAX_DATA_LENGTH]					// work buffer
	;
	SD_BOOL	Encrypted = FALSE;							//Should API Encrypt/Decrypt Data ?
	int		iFields,									//number of "name=value" pairs in the form_data
			ipair,										//current pair
			iAction =-1;								//number of the clicked image button
	LPCSTR 	User_Name,									//ACE/AGENT UseriD
			New_Cookie,									//New ACE/AGENT Cookie
			Old_Cookie,									//Old -------"--------
			Data_Field;									//a Data Field from
	const char *caFields[]={TAG ,				//0
							TAG_DATA,			//1
							CREATE_BUTTON,		//2
							SHOW_BUTTON,		//3
							DELETE_BUTTON,		//4
							TAMPER_BUTTON,		//5
							CHECKBOX,			//6
							};

     //CSRFToken
        LPCSTR CSRFToken;
    //Getting environment variables which we need (set by the server)
	form_data =		getenv("QUERY_STRING");
	ID			=	(char*) ( (cp=getenv("SERVER_NAME")) != NULL ? cp : "" );
	Cookie		=	(char*) ( (cp=getenv("HTTP_COOKIE")) != NULL ? cp : "");
	User		=	(char*) ( (cp=getenv("REMOTE_USER")) != NULL ? cp : "");
	BrowserIP	=	(char*) ( (cp=getenv("REMOTE_ADDR")) != NULL ? cp : "");
	Agent		=	(char*) ( (cp=getenv("HTTP_USER_AGENT")) != NULL ? cp : "");

    //We use this call first to be sure that interface is operational.
        CSRFToken = RSAGetCSRFToken(ID,
                                         Cookie,
                                         User,
                                         BrowserIP,
                                         Agent);

	User_Name = RSAGetUserName(ID,
                               Cookie,
                               User,
                               BrowserIP,
                               Agent);
		if( User_Name == NULL )
	    {
		    Report_Error("WEBID and/or RSACookie API error code is:", RSAGetLastError(), CSRFToken);
		    return EXAMPLE_ERROR;
	    }
        
    //Are there any data? If not -> the CGI was called not from its form.
//suji
FILE* fd = fopen("/tmp/cdtdebug", "a");
fprintf(fd, "the form data is: %s\n", form_data);
fclose(fd);
	if(form_data == NULL)
	{
		Report_Error("Illegal (stand-alone) call to the CGI.",0,CSRFToken);
		return EXAMPLE_ERROR;
	}

	copy_form_data = (char *)malloc(strlen(form_data)*2);
	strcpy(copy_form_data,form_data);
	iFields = 0;
	cp=copy_form_data;

    //Count form elements and values, assign some of them (we are not interested in click coordinates)

	ipair = 0;
	while((token=strtok(cp,"&")) != NULL  && ipair <= N_BUTTONS + N_FIELDS)
	{
		cp=NULL;
		if((cp1=strchr(token,'='))==NULL)
		{
			Report_Error("A token w/out a '=' in it - abort processing.",0,CSRFToken);
			return EXAMPLE_ERROR;
		}
		cp1++;
		for(int i=0; i < sizeof(caFields)/sizeof(char *); i++)
		{
			if(strncmp(token,caFields[i],strlen(caFields[i])) == 0)
			{
				switch (i)
				{
				case 0:
					if(*cp1 != '\0')
					{
						strncpy(Tag,cp1,sizeof(Tag)-1);
					}
					break;
				case 1:
					if(*cp1 != '\0')
					{
						strncpy(Data,cp1,sizeof(Data)-1);
					}
					else
					{
						strcpy(Data," ");
					}
					break;
				case 2:
					iAction = 2;
					break;
				case 3:
					iAction = 3;
					break;
				case 4:
					iAction = 4;
					break;
				case 5:
					iAction = 5;
					break;
				case 6:
					Encrypted = TRUE;
					break;
				default:
					Report_Error("Unknown field or button, processing aborted", 0,CSRFToken);
					return EXAMPLE_ERROR;
				}

			}
		}
	}

    //OK, do what the button asks to do...
	switch (iAction)
	{
    //Create or change
	case 2:
		{
			//There should be a cookie right away, since we are authenticated.
			Data_Field=RSAGetTagField(ID,
                                      Cookie,
                                      User,
                                      BrowserIP,
                                      Agent,
								      Tag,
                                      Encrypted);

			//Requesting a cookie with the "Demo" Tag
			New_Cookie=RSASetTagField(ID,
                                      Cookie,
                                      User,
                                      BrowserIP,
                                      Agent,
					                  "Demo_Tag",
					                  "Demo_Data",
					                  Encrypted);

			//Requesting to add the Tag and Data from the form to the cookie.
            //Please note that we supplied the New_Cookie as a "Cookie"
            //parameter to demonstrate setting of several Tagged Data
            //fields in one invocation of the script.
			New_Cookie=RSASetTagField(ID,
						              New_Cookie,
					                  User,
                                      BrowserIP,
                                      Agent,
					                  Tag,
					                  Data,
					                  Encrypted);

			//Sending HTTP headers; the last empty line IS necessary
			if(New_Cookie != NULL)
			{
		//RSASetTagField () call returns a pointer to a "cookie_name=cookie string",
		// we need just to include it in the HTTP stream with the prefixed "Set-Cookie: " ...
			printf("Set-Cookie: %s;\n",New_Cookie);
			Supply_Headers(CSRFToken);
			//Starting HTML page
			printf("<HEAD>\n<TITLE>Create/Change</TITLE></HEAD>\n<BODY>\n");
			Print_Origin(caFields[iAction]);
			if( New_Cookie == NULL )
			{
				printf("<br><font color=\"#FF0000\">RSAcookie call failed!</font><br>");
					printf("</BODY>\n</HTML>");
			}
			else
			{
			const char *Crypto=(Encrypted ? "ENCRYPTED" :" ");
			Print_Greeting(User_Name);
			Print_Ol_Cookies(Cookie);
			Print_3d_Party(Tag, Data_Field, Encrypted);
			printf("<h4>Setting the field with the tag \"Demo_Tag\" to %s \"Demo_Data\"...</h4>",
																		Crypto);
			printf("<h2><font color=\"#FF0000\">Setting the field with the tag \"%s\" to %s \"%s\"...</font></h2><br>",
				Tag, Crypto, Data);
			}
		//At this moment, we should free memory, allocated for us by RSACookie calls.
			RSAFreeMemory((char*)Data_Field);
			RSAFreeMemory((char*)New_Cookie);
			}
			else
			{
			RSAFreeMemory((char*)Data_Field);
			Report_Error("RSASetTagField() error code is:", RSAGetLastError(),CSRFToken);
			return EXAMPLE_ERROR;
			}
			break;
		}
//Show

	case 3:
		{

    //Extracting the Tagged Data via RSAGetTagField() call
		Data_Field=RSAGetTagField((char*)(ID),Cookie,User,BrowserIP,Agent,
								Tag, Encrypted);
		Supply_Headers(CSRFToken);
		printf("<HEAD>\n<TITLE>Show</TITLE></HEAD>\n<BODY>\n");
		Print_Origin(caFields[iAction]);
		Print_Greeting(User_Name);
		Print_Ol_Cookies(Cookie);
		Print_3d_Party(Tag,Data_Field,Encrypted);
		printf("</BODY>\n</HTML>");
		RSAFreeMemory((char*)Data_Field);
		break;
		}

	case 4: //Delete
		{
		Data_Field=RSAGetTagField((char*)(ID),
                                  Cookie,
                                  User,
                                  BrowserIP,
                                  Agent,
								  Tag,
                                  Encrypted);

	//Deleting the field; a new cookie is returned...
		New_Cookie=RSADeleteTagField((char*)(ID),
                                     Cookie,
                                     User,
                                     BrowserIP,
                                     Agent,
						             Tag);

		if( New_Cookie != NULL )

		{
			printf("Set-Cookie: %s;\n",New_Cookie);
			printf("");

		}
		Supply_Headers(CSRFToken);
		printf("<HEAD>\n<TITLE>Deleting a field</TITLE></HEAD>\n<BODY>\n");
		Print_Origin(caFields[iAction]);
		Print_Greeting(User_Name);
		Print_Ol_Cookies(Cookie);
		Print_3d_Party(Tag,Data_Field,Encrypted);
		printf("<h2>Deleting the field with the tag</h2> \"%s\" ...<br>  ",Tag);
		if(New_Cookie == NULL)
		{
			printf("<br><font color=\"#FF0000\">Could not find either the cookie or the field in it!");
		}
		else
		{
			printf("<br><font size=\"+2\">Success.");

		}
		printf("</BODY>\n</HTML>");
		RSAFreeMemory((char*)New_Cookie);
		RSAFreeMemory((char*)Data_Field);
		break;
		}
	case 5:
    //Tamper.
		{
		char	*b_of_tag,							//beginning of Tag
				*b_of_data,
				*e_of_data;

		int		full_data_length,
				ib_of_tamper,
				ie_of_tamper,
				i_triads;

        //rand() is very predictable so better to use a
		//strong PRNG algorithm, like those found in the BSAFE libraries.
		srand(getpid() + (unsigned int)time(0));
		

		//Get old cookie data, and recreate the cookie to get
		//a pointer to the whole cookie
		Data_Field=RSAGetTagField((char*)(ID),
                                  Cookie,
                                  User,
                                  BrowserIP,
                                  Agent,
								  Tag,
                                  Encrypted);

		if( Data_Field == NULL )
		{
		Report_Error("No such tag, or RSACookieApi failed.",0,CSRFToken);
		return EXAMPLE_ERROR;
		}

		Old_Cookie=RSASetTagField((char*)(ID),
                                  Cookie,
                                  User,
                                  BrowserIP,
                                  Agent,
					              Tag,
					              Data_Field,
					              Encrypted);

		if( Old_Cookie == NULL )
		{
		Report_Error("No such tag, or RSACookieApi failed.",0,CSRFToken);
		return EXAMPLE_ERROR;
		}
		else
		{

    //Corrupt the cookie.
		strcpy(cBuffer,Old_Cookie);
		strcpy(TagEQData,URL_NN);
		strcpy(TagEQData,Tag);
		strcat(TagEQData, URL_EQ);
		b_of_tag = strstr(cBuffer,TagEQData);
		if(b_of_tag == NULL)
		{
		printf("Content-Type:text/html\n");
		printf("\n");

			printf("No such tag  ????<br>\n");
			printf("%s<br>%s<br>",cBuffer,TagEQData);
			return EXAMPLE_ERROR;
		}
		b_of_data = b_of_tag + strlen(Tag) + strlen(URL_EQ);
												    //ASCII for '='
		e_of_data=strstr(b_of_data,URL_NN) - 1;
		if(e_of_data == NULL)
		{
		printf("Content-Type:text/html\n");
		printf("\n");
		printf("Endless data for tag %s  ????<br>\n",Tag);
		printf("%s<br>",cBuffer);
		return EXAMPLE_ERROR;
		}

		full_data_length = (e_of_data - b_of_data )/sizeof(char) + 1;
		if(full_data_length > 1)
		{
		ib_of_tamper = rand()%full_data_length ;
		ie_of_tamper = ib_of_tamper + rand()%(full_data_length - ib_of_tamper);
		}
		else
		{
			ib_of_tamper=ie_of_tamper=0;
		}
    //Let's change the bytes of data randomly
		for(int i=ib_of_tamper; i <= ie_of_tamper; i++)
		{
		*(b_of_data + i)='@' + rand()%('~' - '@');
		}

			printf("Set-Cookie: %s;\n",cBuffer);
			printf("");
			i_triads = 0;
			for(cp=cBuffer; cp <= b_of_data+ib_of_tamper; cp++)
			{
				if(*cp == '%')
				{
					i_triads++;
				}
			}
		Supply_Headers(CSRFToken);
		printf("<HEAD><TITLE>Tamper</TITLE></HEAD><BODY>\n");
		Print_Origin(caFields[iAction]);
		Print_Greeting(User_Name);
		printf("<font size =\"+3\">%s</font>","THE RESULT OF THIS SHOULD BE LOSS OF AUTHENTICATION.");

		strcpy(Data,RSAGetTagField((char*)(ID),
                                   Cookie,
                                   User,
                                   BrowserIP,
                                   Agent,
								   Tag,
                                   Encrypted));

		printf("<h2>Recreating the field with the tag </h2>\"%s\" </h2>and the same data as before.<br>"
			"Here is the whole cookie:"
			"<h2>\"%s\"</h2>...",
			Tag,Old_Cookie);
		printf("Trying to set the cookie with randomly changed bytes,"
			" starting from the byte <font><strong>%d</strong></font> from the beginning of the cookie",
			ib_of_tamper+ (b_of_tag-cBuffer)/sizeof(char) -2 -i_triads*2);
			printf(": <br>"
	//We use "*s" format, it will require number of characters to print as the next argument
			"<h2>%.*s%s%.*s%s%s</h2><br>"
			"instead of the proper one.",
			ib_of_tamper +(b_of_data - cBuffer)/sizeof(char), //number of chars to print
			cBuffer,
			"<font color=\"#FF0000\">",
			(ie_of_tamper - ib_of_tamper + 1)/sizeof(char),
			b_of_data + ib_of_tamper,
			"</font>",
			b_of_data + ie_of_tamper + 1
			);
		printf("</BODY>\n</HTML>");

		RSAFreeMemory((char*)Old_Cookie);
		RSAFreeMemory((char*)Data_Field);
	}
			break;
			}//End of case  5 ("Tamper")

	default:
        Supply_Headers(CSRFToken);
        printf("<HEAD><TITLE>Tamper</TITLE></HEAD><BODY>\n");
		printf("<br><font color=\"#FF0000\">The button %s is not implemented yet!",	caFields[iAction]);
        printf("</BODY>\n</HTML>");
		return 0;

}
	printf("<hr><font size=\"+3\">Please use your browser's \"BACK\" feature to return to the starting page.</font>"
			"</body></html>");
	RSAFreeMemory((char*)CSRFToken);		
  return 0;
  }

  //***************** helper routines *******************************


  static void Print_Ol_Cookies(char *Cookie)
  {
	  	printf("<hr><h2><br>ALL Cookies were:<br></h2>\n");

	  	for(int i=0; Cookie[i]!='\0'; i++)
	{
		printf("%c", Cookie[i] );
		if (Cookie[i] == ';')
		{
			printf("<br><br>\n");
		}
	}
  }


static void Print_Greeting(const char *User_Name)
{
  time_t tm;

  time(&tm);
  printf("<H2>Hello,&nbsp;%s&nbsp;. ",User_Name);
  printf("It is %s now.%s",
	ctime(&tm),
	"</h2>"	);
}

static void Print_3d_Party(char *Tag, const char *Old_Cookie,SD_BOOL Encrypted)
{
if (Tag && Old_Cookie)
printf("<h1>The 3-d party cookie %s data for the tag </h1>\"%s\" <h1>ARE:</h1>%s",(Encrypted ? "DECRYPTED" :" "), Tag,Old_Cookie);
}

static void Print_Origin(const char *Action)
{
	if(Action == NULL)
	{
		Action = "ButtonUNKNOWN";
	}

	printf("This is the output from a compiled \"C\" script.<br><h1>%s</h1>",strstr(Action,"Button")+strlen("Button"));
}

static  void Print_Logoff(LPCSTR CSRFToken)
{
	char *ID, *cp;
	LPCSTR pWebIDURL;
	ID = (char*)((cp=getenv("INSTANCE_ID")) != NULL ? cp : "");
	pWebIDURL = RSAGetWebIDURL(ID);
    printf("<p align=right><a href=\"%s?logoff?RSArand=%s\">Logoff</a></p>", pWebIDURL, CSRFToken);
	RSAFreeMemory((char*)pWebIDURL);
}

static void Report_Error(const char* Error, int detail, LPCSTR CSRFToken)
{

Supply_Headers(CSRFToken);
printf("<HEAD>\n<TITLE>%s</TITLE></HEAD>\n<BODY>\n",Error);
printf("<br><font color=\"#FF0000\">%s</font><br>",Error);
if(detail !=0)
{
	printf(" %d",detail);
}
printf("</BODY>\n</HTML>");

}

static void Supply_Headers(LPCSTR CSRFToken)
{
printf("Content-Type:text/html\n");
printf("\n");
printf("<HTML>\n");
Print_Logoff(CSRFToken);
}



















