#!/usr/bin/perl

#####################################################################
# This script does the following things:
# 1. Sets a third party tag data in the cookie's third party field
# 2. Invokes another script called deleteTag.pl
#####################################################################

# Get data from the HTML form and parse it
$form_data = $ENV{'QUERY_STRING'};
@pairs=split(/&/,$form_data);
foreach $item(@pairs){
   ($key,$content)=split(/=/,$item,2);
   $content=~tr/+/ /;
   $content=~ s/%(..)/pack("c",hex($1))/ge;
   $fields{$key}=$content;
}

$nickname = $fields{'nickname'};
$data = $fields{'data'};

$Cookies = $ENV{'HTTP_COOKIE'};

# Set new tag and data to existing cookie
$New_Cookies=`./rsacookie -s -tag $nickname -data $data`;
$result=$? >>8;
if( $result != 0 )
{
	print "Content-Type:text/html\n\n";
	print "<HEAD>\n<TITLE>RSACookie API or RSACookie are absent</TITLE></HEAD>\n<BODY>\n";
	print "<br><font color=\"#FF0000\">Set new cookie failed</font><br>";
	print "<br><font color=\"#FF0000\">The error code is: $result </font><br>";
	print "</BODY>\n</HTML>"; 
	exit(0);
}

#Set the Cookies Header to the browser
print "Set-Cookie: $New_Cookies\n";

# Get username out from cookies
$UserName = `./rsacookie -g -user`;

$result=$? >>8;
if( $result != 0 )
{
	print "Content-Type:text/html\n\n";
	print "<HEAD>\n<TITLE>RSACookie API or RSACookie are absent</TITLE></HEAD>\n<BODY>\n";
	print "<br><font color=\"#FF0000\">Get user field failed</font><br>";	
	print "<br><font color=\"#FF0000\">The error code is: $result </font><br>";
	print "</BODY>\n</HTML>"; 
	exit(0);
}
# Get the CSRF Token from cookie
$CSRFToken = `./rsacookie -g -CSRFToken`;
$result=$? >>8;
if( $result != 0 )
{
	print "Content-Type:text/html\n\n";
	print "<HEAD>\n<TITLE>RSACookie API or RSACookie are absent</TITLE></HEAD>\n<BODY>\n";
	print "<br><font color=\"#FF0000\">Get CSRF Token field failed</font><br>";	
	print "<br><font color=\"#FF0000\">The error code is: $result </font><br>";
	print "</BODY>\n</HTML>"; 
	exit(0);
}

# Get WebID URL from settings.
$WebIDURL = `./rsacookie -g -webIdURL`;
$result=$? >>8;
if( $result != 0 )
{
	print "Content-Type:text/html\n\n";
	print "<HEAD>\n<TITLE>RSACookie API or RSACookie are absent</TITLE></HEAD>\n<BODY>\n";
	print "<br><font color=\"#FF0000\">Get WebID URL field failed</font><br>";	
	print "<br><font color=\"#FF0000\">The error code is: $result </font><br>";
	print "</BODY>\n</HTML>"; 
	exit(0);
}

print "Content-type: text/html\n\n";
print "<html>";
print "<title>Cookie Sample</title>\n";
print "<body>";
print "<p align=right><a href=$WebIDURL?logoff?RSArand=$CSRFToken>Logoff</a></p>";
print "<p>User name field: $UserName<p>";
print "<p>Cookies = $Cookies<p>";
print "<p>NewCookies = $New_Cookies";

print "<p><a href=\"getAndDelTag.pl?nickname=$nickname&data=$data\">show new cookie</a>";
print "</body></html>";
