<%@LANGUAGE="VBScript"%>

<!***********************************************************
Example VBScript Script to demonstrate Redirection,
without Web Agent restriction, to any desired URL, 
after invoking Web Agent authentication on the WebSite
of the Script.  

The practical implementation of an actual-use Script,
however, may limit access to only certain Web Sites and
URLs chosen by the Web Administrator.  The implied intent, 
of providing a Script for redirection, is to transfer 
control of Redirected URL restriction from the Web Agent
System to the Web Administrator.

To control access to "allowable" Web Sites or URLs that a 
user might attempt Redirection to, an actual-use Script would
perform string comparisons between the expanded "Redirection"
argument to this Script, "$targetURL", and a list of "allowable"
or "dis-allowable" URLs or &lt;hostname.domain&gt; combinations
imbedded in the URL.  This list would be maintained by the 
Web Administrator.

Example specification of script invocation, in a URL, is 
as follows:

Windows:
-------
  http://HostName/WebID/IISWebAgentIF.dll
   ?referrer=/Scripts/AspScriptRedirect.asp
     ?target=http://RedirectHostName/file.txt

Unix:
-------
  http://HostName/webauthentication
   ?referrer=/Scripts/AspScriptRedirect.asp
     ?target=http://RedirectHostName/file.txt

The HTML code, including the "href" statement, in this example, 
presents a method of fallback Redirection in case of failure of 
the "302 Header" to accomplish the same ends.  Ideally, one would 
never see the "Redirect" page defined by this HTML, for the 
"302 Redirect Header" should take the user directly to the desired
URL.
*****************************************************************>

<%
    Dim targetURL

    targetURL = "/"

    If Request.QueryString("target").Count > 0 Then
        targetURL = Request.QueryString("target")
    End If
	
    Response.ContentType = "text/html"
%>


<!***************************************************************
An "actual-use" Script would perform string comparisons,
HERE, between the input URL, (including &lt;hostname.domain&gt;),
and a list of "allowable" or "dis-allowable" URLs or
&lt;hostname.domain&gt; combinations.  The input URL is represented
in "$targetURL".
*****************************************************************>


<HTML>

    <HEAD><TITLE>CGI Script Redirect</TITLE></HEAD>

    <BODY>

        <CENTER>

            <FONT COLOR="red">
                <H1>CGI Script Redirect</H1>
            </FONT>

<%
' Protect against HTTP Response Splitting. Check for invalid characters in URL
If ((InStr(targetURL,"\n")>0) OR (InStr(targetURL,vbLF)>0) OR (InStr(targetURL,"\r")>0) OR (InStr(targetURL,vbCR)>0)) Then
%>

<P><H2>Invalid characters were detected in the URL<strong></strong></H2></P>
<FORM><P><H2><INPUT type=button value="Back" onClick="history.back()"</H2></P></FORM><HR>

<%
Else
' All valid charaters, allow redirection
	Response.Redirect(targetURL)
End If
%>
            

        </CENTER>
    </BODY>

</HTML>
